/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __terminal_TerminalDraw_h__
#define __terminal_TerminalDraw_h__

namespace fe
{

/**************************************************************************//**
    @brief Draw to terminal buffer

	@ingroup terminal
*//***************************************************************************/
class FE_DL_EXPORT TerminalDraw: public DrawCommon
{
	public:
					TerminalDraw(void)										{}
virtual				~TerminalDraw(void)										{}

					//* as DrawI
virtual void		drawPoints(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							BWORD multicolor,const Color *color);

virtual	void		drawLines(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color *color);
virtual void		drawTriangles(const SpatialVector *vertex,
							const SpatialVector *normal,
							const Vector2f *texture,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color* color);

					//* Terminal specific

		void		setSurfaceAccessible(
							sp<SurfaceAccessibleI> a_spSurfaceAccessibleI)
					{	m_spSurfaceAccessibleI=a_spSurfaceAccessibleI; }

		sp<SurfaceAccessibleI>	surfaceAccessible(void)
					{	return m_spSurfaceAccessibleI; }

	private:
		void		drawPolygons(const SpatialVector *vertex,
							const SpatialVector *normal,U32 vertices,
							StripMode strip,BWORD multicolor,
							const Color *color,BWORD openPoly);

		sp<SurfaceAccessibleI>	m_spSurfaceAccessibleI;
};

} // namespace

#endif /* __terminal_TerminalDraw_h__ */
