import sys
forge = sys.modules["forge"]

import os.path

def setup(module):

	srcList = [	"DrawPlant",
				"PlantSketch",
				"SimPlant",
				"Tree.cc",
				"TreeOp",
				"vegetationDL" ]

	deplibs = forge.corelibs + [
				"feSignalLib",
				"fexMathLib",
				"fexOperatorDLLib",
				"fexDataToolDLLib"]

	module.cppmap = {}

	if 'solve' in forge.module_list and os.path.exists('ext/solve'):
		module.cppmap['solve'] = ' -DFE_VEG_SOLVE'
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write("-solve ")
		forge.color_off()

	dll = module.DLL( "fexVegetationDL", srcList )

	forge.deps( ["fexVegetationDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"fexVegetationDL",				None,		None) ]

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer') and os.path.exists('ext/vegetation/test'):
		module.cppmap['solve'] = ' -DFE_VEG_VIEWER'
		module.Module( 'test' )
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write("-viewer ")
		forge.color_off()
